local inCombat = nil

local dndString = "I'm busy fighting %s, he's currently at %d%%."
local combatEndedString = "Combat ended after %d minutes."

do
	local locale = GetLocale()
	if locale == "deDE" then
		dndString = "Ich bin im Kampf mit %s, er hat noch %d%% Leben."
		combatEndedString = "Kampf beendet nach %d Minuten."
	end
end

local whisperers = {}
local combatStart = nil
local boss = nil
local bossHp = nil

local orig = ChatFrame_MessageEventHandler
ChatFrame_MessageEventHandler = function(event, ...)
	if combatStart and type(arg2) == "string" then
		if event == "CHAT_MSG_WHISPER" then
			whisperers[arg2] = true
			SendChatMessage(dndString:format(boss, bossHp), "WHISPER", nil, arg2)
			return
		elseif event == "CHAT_MSG_WHISPER_INFORM" and whisperers[arg2] then
			return
		end
	end
	return orig(event, ...)
end

local function checkTarget(id)
	return UnitExists(id) and UnitAffectingCombat(id) and UnitClassification(id) == "worldboss"
end

local function scan()
	if checkTarget("target") then return "target" end
	if checkTarget("focus") then return "focus" end
	if UnitInRaid("player") then
		for i = 1, 40 do
			if checkTarget("raid"..i.."target") then return "raid"..i.."target" end
		end
	else
		for i = 1, 5 do
			if checkTarget("party"..i.."target") then return "party"..i.."target" end
		end
	end
end

local frame = CreateFrame("Frame")
frame:SetScript("OnEvent", function()
	if event == "PLAYER_REGEN_DISABLED" then
		local target = scan()
		if not target then return end
		combatStart = GetTime()
		boss = UnitName(target)
		bossHp = UnitHealth(target)
		frame:RegisterEvent("UNIT_HEALTH")
	elseif event == "PLAYER_REGEN_ENABLED" and combatStart then
		local time = GetTime() - combatStart
		local msg = combatEndedString:format(math.floor(time / 60))
		for k, v in pairs(whisperers) do
			-- Notify people that combat has ended
			SendChatMessage(msg, "WHISPER", nil, k)
			whisperers[k] = nil
		end
		combatStart = nil
		boss = nil
		bossHp = nil
		frame:UnregisterEvent("UNIT_HEALTH")
	elseif event == "UNIT_HEALTH" and arg1 and UnitName(arg1) == boss then
		bossHp = UnitHealth(arg1)
	end
end)

frame:RegisterEvent("UNIT_TARGET")
frame:RegisterEvent("PLAYER_REGEN_DISABLED")
frame:RegisterEvent("PLAYER_REGEN_ENABLED")

